<?php

namespace FiloBlu\LogView\Block\Adminhtml\Log;

use Magento\Backend\Block\Widget\Grid\Extended;
use Magento\Backend\Block\Template\Context;
use Magento\Backend\Helper\Data;
use FiloBlu\LogView\Model\ResourceModel\Log\Collection;

class Grid extends Extended {

    /**
     * @var Collection
     */
    protected $_collection;

    /**
     * Constructor
     *
     * @param Context $context
     * @param Data $backendHelper
     * @param Collection $collection
     * @param array $data
     */
    public function __construct(
    Context $context, Data $backendHelper, Collection $collection, array $data = []
    ) {
        $this->_collection = $collection;

        parent::__construct($context, $backendHelper, $data);
    }

    /**
     * @return void
     */
    protected function _construct() {
        parent::_construct();
        $this->setId('logs_grid');
        $this->setDefaultSort('filename');
        $this->setDefaultDir('DESC');
//        $this->setSaveParametersInSession(true);
//        $this->setVarNameFilter('logs_record');
    }

    protected function _prepareCollection() {

        $this->setCollection($this->_collection);
        return parent::_prepareCollection();
    }

    protected function _prepareColumns() {
        $this->addColumn(
                'filename', [
            'header' => __('File Name'),
            'index' => 'filename',
            'sortable' => true,
            'filter' => false
                ]
        );

//        return parent::_prepareColumns();
    }

    public function getRowClickCallback() {
        $js = '
                function (grid, event) {
                    var trElement = Event.findElement(event, "tr");
                    
                    var fileName = trElement.down("td").innerHTML;
                   
                   var url = "' . $this->_backendHelper->getUrl(
                        'filoblulogviewadmin/log/view', [
                        ]
                ) . 'file_name/" + fileName.replace(/^\s+|\s+$/g,"");
            window.open(url);
                }
            ';


        return $js;
    }

}
